/******************************************************************************
* Find the number of columns in the file stream;
* ignore lines beginning with '#'
******************************************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define L_WORD  2000   /* Longest string that can be handled */


int ncolumns(FILE *data_file) {

  int      i, len, n;
  char     buffer[L_WORD];
  void     errormsg(char *, ...);


  do {
    if (fgets(buffer, L_WORD, data_file) == NULL)
      errormsg("ncolumns(): Couldn't read from file stream!");
  } while (buffer[0] == '#');

  len = strlen(buffer);

  n = 0;
  for (i = 1; i < len; i++)
    if (isspace(buffer[i]) && !isspace(buffer[i-1]))
      n++;

  rewind(data_file);

  return n;
}
