/******************************************************************************
* Read a double column identified by its number from a catalogue file;
* *n should contain the actual size of par[]
******************************************************************************/

#include <stdio.h>
#include <string.h>

#define L_WORD 2000


void readdcoln(int icol, char *cat, double par[], int *n) {

  int            i;
  char           buffer[L_WORD], format[L_WORD];
  FILE           *data_file;
  int            ncolumns(FILE *);
  FILE           *faskropen(char *, char *, int);
  void           errormsg(char *, ...), warnmsg(char *, ...);


  /* Open the file */
  if ((data_file = faskropen("Catalogue?", cat, 3)) == NULL)
    errormsg("readdcoln(): Couldn't open %s!", cat);

  /* Count the columns */
  i = ncolumns(data_file);

  /* Check column number */
  if (icol < 1 || icol > i)
    errormsg("readdcoln(): Column %d doesn't exist in %s!", icol, cat);

  /* Make the format string */
  format[0] = '\0';
  for (i = 0; i < icol-1; i++)
    strcat(format, "%*s ");
  strcat(format, "%lf");

  /* Read in the data */
  i = 0;
  while (i < *n && fgets(buffer, L_WORD, data_file) != NULL)
    if (buffer[0] != '#') {
      if (sscanf(buffer, format, &par[i]) != 1)
	errormsg("readdcoln(): Having trouble reading the data!");
      i++;
    }

  /* See if there's more data */
  if (i == *n && fgets(buffer, L_WORD, data_file) != NULL)
    warnmsg("readdcoln(): Not enough space to read all data from %s!", cat);
    
  *n = i;
  fclose(data_file);

  return;
}
